
#ifndef _SYN1588_COMPATIBILITY_OF_H
#define _SYN1588_COMPATIBILITY_OF_H

#include "compat_rhel.h"

#include <linux/version.h>

#if  KERNEL_VERSION(4, 0, 0) > LINUX_VERSION_CODE
#ifdef CONFIG_OF
static inline bool of_device_is_big_endian(const struct device_node *device)
{
	if (of_property_read_bool(device, "big-endian"))
		return true;
	if (IS_ENABLED(CONFIG_CPU_BIG_ENDIAN) &&
	    of_property_read_bool(device, "native-endian"))
		return true;
	return false;
}
#else
static inline bool of_device_is_big_endian(const struct device_node *device)
{
    return false;
}
#endif // CONFIG_OF
#endif

#endif // _SYN1588_COMPATIBILITY_OF_H