#!/bin/bash

# this script sould be run from the src folder

VERSION=`git describe --tags --dirty 2>/dev/null`

# on error
if [[ $? -ne 0 ]]; then
	if [[ ! -e version.h ]] ; then
		echo "error version not found, please create a 'version.h' file"
		exit 1;
	fi
	# do nothing, no git found, file exists
	exit 0
fi

cat > version.h << EOF
#define DRV_VERSION "${VERSION}"
EOF
