#include "delay_correction.h"

#include <linux/ethtool.h>
#include <linux/printk.h>



// source is an032_phy_delay.docx

const syn1588_phydelay_t phy_delays_default = {
	.mac = {
		.rx = 0,
		.tx = 0
	},
	.clock_m = {
		.rx = 0,
		.tx = 0
	},
};

const syn1588_phydelay_t phy_delays_pci_nic_2_base_t_1000 = {
	.mac = {
		.rx = 387,
		.tx = 155
	},
	.clock_m = {
		.rx = 387,
		.tx = 147
	},
};

const syn1588_phydelay_t phy_delays_pci_nic_2_base_t_100 = {
	.mac = {
		.rx = 569,
		.tx = 282
	},
	.clock_m = {
		.rx = 569,
		.tx = 242
	},
};

const syn1588_phydelay_t phy_delays_pci_nic_2_sfp_base_x_1000 = {
	.mac = {
		.rx = 140,
		.tx = 52
	},
	.clock_m = {
		.rx = 140,
		.tx = 44
	},
};
const syn1588_phydelay_t phy_delays_pci_nic_2_sfp_base_t_1000 = {
	.mac = {
		.rx = 507,
		.tx = 428
	},
	.clock_m = {
		.rx = 507,
		.tx = 420
	},
};
const syn1588_phydelay_t phy_delays_pci_nic_2_sfp_base_t_100 = {
	.mac = {
		.rx = 851,
		.tx = 972
	},
	.clock_m = {
		.rx = 851,
		.tx = 932
	},
};


syn1588_phydelay_t get_pci_nic_2_copper_hw_delay(enum ethtool_link_mode_bit_indices mode) {
	switch(mode){
	case ETHTOOL_LINK_MODE_1000baseT_Full_BIT:
		return phy_delays_pci_nic_2_base_t_1000;
		break;
	case ETHTOOL_LINK_MODE_100baseT_Full_BIT:
		return phy_delays_pci_nic_2_base_t_100;
		break;
	default:
		pr_warn("unknown phy delay for current mode\n");
	}

	return phy_delays_default;
}

syn1588_phydelay_t get_pci_nic_2_sfp_hw_delay(enum ethtool_link_mode_bit_indices mode) {
	syn1588_phydelay_t delay = {};

	switch(mode){
	case ETHTOOL_LINK_MODE_1000baseT_Full_BIT:
		return phy_delays_pci_nic_2_sfp_base_t_1000;
		break;
	case ETHTOOL_LINK_MODE_100baseT_Full_BIT:
		return phy_delays_pci_nic_2_sfp_base_t_100;
		break;
	case ETHTOOL_LINK_MODE_1000baseX_Full_BIT:
		return phy_delays_pci_nic_2_sfp_base_x_1000;
		break;
	default:
		pr_warn("unknown phy delay for current mode\n");
	}
	return delay;
}

syn1588_phydelay_t get_device_tree_hw_delay(enum ethtool_link_mode_bit_indices mode) {
	syn1588_phydelay_t delay = {};

	return delay;
}