

#ifndef _OREGANO_TSE_MAC_SFP_H_
#define _OREGANO_TSE_MAC_SFP_H_

#include "compat/sfp.h"

#include <linux/i2c.h>
#include <linux/types.h>

enum oregano_mac_sfp_state {
	SFP_NOT_INIT = 0,
	SFP_PROBED = 1,
};

struct oregano_mac_sfp {
	struct i2c_adapter *i2c;
	struct mii_bus *mii_bus;
	struct net_device *net_dev;
	phy_interface_t interface;
	enum oregano_mac_sfp_state state; // current state of internal state machine

	// status of fpga PCS/PMA
	bool link_status;

	struct {
		u8 base[64];
		u8 extd[32];
		u8 vendor[32];
	} eeprom;
	
};


int oregano_mac_sfp_probe(struct device *dev, struct oregano_mac_sfp *sfp, struct net_device *net_dev, struct i2c_adapter *i2c_adapter, phy_interface_t interface);
void oregano_mac_sfp_exit(struct oregano_mac_sfp *sfp);

bool oregano_mac_sfp_connected(struct oregano_mac_sfp *sfp);
void oregano_mac_sfp_set_phylink(struct oregano_mac_sfp *sfp, bool link_status);

/**
 * this function should be called after a spf module becomes ready
*/
int oregano_mac_sfp_probe_phy(struct oregano_mac_sfp *sfp, void (*phy_handler)(struct net_device *ndev));


void oregano_mac_sfp_exit_phy(struct oregano_mac_sfp *sfp);


const struct sfp_eeprom_base *oregano_mac_sfp_get_eeprom_base(struct oregano_mac_sfp *sfp);
const u8 *oregano_mac_sfp_get_eeprom_raw(struct oregano_mac_sfp *sfp);

bool oregano_mac_sfp_is_sff8472_compliance(struct oregano_mac_sfp *sfp);


#endif // _OREGANO_TSE_MAC_SFP_H_